/*
 * EditeurRayon.java
 *
 * Created on 10 juillet 2006, 19:49
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;
import Applet.AppletMathGraph32;
import objets.*;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class EditeurRayon extends EditeurValeurDynamique {
  
  /** Creates a new instance of EditeurRayon */
  public EditeurRayon(AppletMathGraph32 appletInit, 
      CValeurAssocieeAVariable valInit, CElementBase objetInit) {
    super(appletInit,  valInit,  objetInit); 
  }

   /**
   * Fonction charge de vrifier si la rponse, quand elle est correcte, est valide
   * pour le type de valeur attendu. Par exemple, le rayon d'un cercle doit tre non nul.
   * Renvoie true par dfaut et doit tre redfinie pour tous les descendants.
   *
  */
  public boolean valeurAcceptee(double v) {
    if (v == 0) {
      MtgDlg.dialogueAvertissement(textes.Chaines.ch9);
      requestFocus();
    }
    return (v != 0);
  }
}
