/*
 * ListeValeurs.java
 *
 * Created on 9 juillet 2006, 09:53
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;
import java.util.*;
import javax.swing.*;
import objets.*;
import types.*;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class ListeValeurs extends JList {
  private CListeObjets liste; // La liste contenant les valeurs  afficher
  private int indiceMaxi; // l'indice maxi permis pour un objet  insrer dans la liste
  
  /**
   * Creates a new instance of ListeValeurs 
   */
  public ListeValeurs(CListeObjets listeInit, int indiceMaxiInit) {
    super();
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste = listeInit;
    indiceMaxi = indiceMaxiInit;
    int i = 0;
    
    Vector<String> values = new Vector<String> ();
    // On ajoute les noms des objets de type valeurs  la liste
    ListIterator<CElementBase> li = liste.listIterator();
    while (i <= indiceMaxi)
    {
      CElementBase elb = (CElementBase) (li.next());
      if ((elb.getNatureCalcul() & NatureCalcul.NTouteValeurReelle) != 0) {
        values.add(elb.nom());
      }
      i++;
    }
    setListData(values);
    setVisibleRowCount(6);

    setSelectedIndex(0);
  }  
}
