/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package entreesSorties;

import java.io.*;
import java.util.*;

import objets.CObjetBase;

/**
 *
 * @author Yves
 */
public class MathGraphDataOutputStream extends DataOutputStream {
  ArrayList<String> listeNomsClasse = new ArrayList<String>();
  /** Creates new MathGraphDataOutputStream */
    public MathGraphDataOutputStream(OutputStream out) {
      super(out);
  }
  /* Nouvelle version de serialization en java. Ecriture */
  public final void writeObject(CObjetBase ob)
    throws IOException {
    int i;
    String nomClasse = ob.getClass().getName();
    int numVer = ob.numeroVersion(); // Numro de version
    // On regarde d'abord si un objet de cette classe a dj t enregistr dans le flux.
    // Si oui on enregistre dans le flux son indice dans la liste des classes dj
    // charges dans la liste listeNomsClasses.
    // Sinon on enregistre un short FFFF suivi du numro de version de l'objet
    // suivi du nom de la classe
    boolean trouve = false;
    for (i = 0; (i < listeNomsClasse.size()) && !trouve; i++) {
      String ch = (String) listeNomsClasse.get(i);
      if (ch.compareTo(nomClasse) == 0) {
        trouve = true;
        break;
      }
    }
    if (trouve) {
      writeInt(i);
    }
    else {
      writeInt(-1);
      writeInt(numVer);
      writeUTF(nomClasse);
      listeNomsClasse.add(nomClasse);      
    }
    ob.write(this, ob.listeProprietaire);
  }
  
  /**
   * Appel pour enregistrer les caractres successifs d'une chane dans le flux
   * Ne sera appel que pour enregistrer la chane d'identification
   * De cette faon le document pourra tre lu par l'applet de la mme faon
   * que les figures issues du C++
   * @param chaine
   * @return
   * @throws IOException
   */
  public final void writeCString(String chaine) throws IOException {
    for (int i = 0; i < chaine.length(); i++) {
      this.writeByte(chaine.charAt(i));
    }
  }
  
  
}
