/*
 * CFoncComplexe.java
 *
 * Created on 29 janvier 2007, 13:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;
import types.*;

/**
 *
 * @author yves.bitton
 */
public class CFoncComplexe extends CFonc {
  
  /** Creates a new instance of CFoncComplexe */
  public CFoncComplexe() {
  }
  
  /* Constructeur pour outil de cration */
  public CFoncComplexe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
  }
  
  /* Constructeur pour clonage */
  public CFoncComplexe(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    String nomInit,String chaineCalculInit, CCalculBase calculInit, String chaineVariableInit) {
    super(liste, impProtoInit, estElementFinalInit, nomInit, chaineCalculInit, calculInit, chaineVariableInit);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1= listeSource.indexOf(impProto);        
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    CElementBase ptelb = new CFoncComplexe(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, nomCalcul, chaineCalcul, calculClone, chaineVariable);
    return ptelb;    
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NFonctionComplexe;
  }
  
  void rendValeurFonctionComplexe(boolean infoRandom, Complexe parametre, Complexe zRes)
      throws ErreurCalculException {
    calcul.resultatFonctionComplexe(infoRandom, parametre, zRes);
  }
  
   // Inutile de redfinir informationModification() pour les objets de type calcul    
  
   /**
    * Pour savoir si le calcul est une fonction relle, une suite relle ou non
    * Redfini seulement pour CFonc, CFoncComplexe, CSuiteRec et CSuiteRecComplexe;
    */ 
   public boolean estFonctionOuSuite() {
     return true;
   }
   
}
