/*
 * CTransformation.java
 *
 * Created on 9 juillet 2004, 18:29
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Classe anctre de toutes les transformations gomtriques.
import java.awt.geom.*;
import types.*;


// Modification de la versio 2.5 : la classe n'est plus abstract pour cause de chargement
// de prototype. Peut tre instancie dans CListeObjets.get(int indice, Class cla)
public abstract class CTransformation extends CElementBase {
	protected static final int translation = 1;
	protected static final int rotation = 2;
	protected static final int symetrieCentrale = 3;
	protected static final int symetrieAxiale = 4;
	protected static final int homothetie = 5;
	protected static final int similitude = 6;
	protected static final int inversion = 7;

	/** Creates new CTransformation */
	public CTransformation() {
	}

	public CTransformation(CListeObjets liste, CImplementationProto impProtoInit,
			boolean estElementFinalInit) {
		super(liste, impProtoInit, estElementFinalInit);
	}

	@Override
	public long getNature() {
		return NatureObjet.NTransformation;
	}
	
	/**
	 * Renvoie la nature de la transformation
	 * @return
	 */
	public abstract int natureTransformation();
	

	/**
	 * Sert lors de l'historique Est redfini pour la translation et ermet
	 * d'ajouter  la liste visuelle un vecteur
	 * 
	 * @param liste
	 */
	void AjouteElementsVisuelsPourHist(CListeObjets liste) {
	}

	/**
	 * Chaine pour l'historique indiquant la nature de la transformation
	 * 
	 * @return
	 */
	abstract String designationTransf();

	/**
	 * Certaine transformation renvoient dans cette chaine des complments 
	 * rajouter l'historique
	 * 
	 * @return
	 */
	String complementPourHist() {
		return "";
	}

	public void transformePoint(double x, double y, Point2D.Double pointr) {
	}

	void transformeAngle(double ang, Point2D.Double pointr) {
		pointr.x = ang;
	}

	void transformeVecteur(VecteurDirecteur u, VecteurDirecteur ur) {
	}

	public double transformeLongueur(double L) {
		return 0;
	}

	/**
	 * Procdure renvoyant true si le point a une image Sera true sauf pour
	 * l'inversion si on veut l'image du centre
	 * 
	 */
	public boolean pointAUneImage(CPointAncetre point) {
		return true;
	}
}

