/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;

import Applet.AppletMathGraph32;
import Applet.GestionnaireEdition;
import java.awt.Toolkit;
import java.io.IOException;

/**
 *
 * @author Yves
 */
public class OutilAnnuler extends Outil {
  public OutilAnnuler(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false);
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Annuler.gif";
  }
  
  public String chaineInfo() {
    GestionnaireEdition gest = appletMere.gestionnaire;
    if (gest.annulationPossible()) return textes.Chaines.ch13 + appletMere.gestionnaire.chaineNatureAnnulationEnCours();
    else return "";
  }

  public String toolTip() {
    return textes.Chaines.toolTip1;
  }
  
  public void select() {
    super.select();
    try {
      if (appletMere.gestionnaire.annulationPossible()) {
        appletMere.gestionnaire.annuleAction();
        appletMere.information(chaineInfo());
      }
      else Toolkit.getDefaultToolkit().beep();
    }
    catch (IOException err) {}
    appletMere.activeOutilCapture();
  }
}
