package outils;

import objets.CListeObjets;
import dialogs.ModificationFormuleDlg;
import Applet.AppletMathGraph32;

public class OutilModifierFormule extends Outil {
	public OutilModifierFormule(AppletMathGraph32 appletInit) {
		super(appletInit, true, AppletMathGraph32.iconModifierFormule);
	}
	  
  @Override
  public int idMenu() {
    return 32883;
  }
  
  @Override
	public void select() {
    super.select();
    appletMere.indication(getString("modifierFormule1"));
    ModificationFormuleDlg dlg = new ModificationFormuleDlg(appletMere, appletMere.listeConstruction.size() - 1);
    dlg.setLocationRelativeTo(appletMere);
    dlg.setVisible(true);
    /* Pas pour l'pplet
    // Il faut redonner le focus au frame car on peut avoir cr le dialogue d'affichage de valeurs en bas et  droite
		frame.mtgDesktopPane.getDesktopManager().activateFrame(frame.cadreActif());		
    frame.requestFocus();
    */
    appletMere.activeOutilCapture();
	}
  
  @Override
  public boolean activationValide() {
  	CListeObjets liste = appletMere.listeConstruction;
  	return (liste.nombreCalculsModifiablesParMenu() != 0);
  }
  
}
