/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;

import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CPointAncetre;

import types.NatureObjet;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class EntreeNomDlg extends MtgDlg {
  CElementGraphique elementAssocie; // L'lment que l'on cherche  renommer
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private javax.swing.JTextField editeurNom;
  private javax.swing.JLabel label1;
  // End of variables declaration

  public EntreeNomDlg(AppletMathGraph32 appletInit, CElementGraphique elementAssocieInit) {
    super (null, textes.Chaines.ch21, true, appletInit);
    elementAssocie = elementAssocieInit;
    initComponents();
    getRootPane().setDefaultButton(btnOK);
    editeurNom.setText(elementAssocie.rendNom());
    editeurNom.setSelectionStart(0);
    editeurNom.setSelectionEnd(editeurNom.getText().length());
    editeurNom.requestFocus();
  }
  private void initComponents() {
    label1 = new JLabel(textes.Chaines.entreeNomDlg1, JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    editeurNom = new javax.swing.JTextField();
    editeurNom.setColumns(8);
    btnOK = new javax.swing.JButton(textes.Chaines.btnOK);
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(textes.Chaines.btnCancel);
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    JPanel panePrincipal = new JPanel();
    JPanel paneRight = new JPanel();
    panePrincipal.setLayout(new FlowLayout());
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    panePrincipal.add(label1);
    panePrincipal.add(editeurNom);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();
  }
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {
    CListeObjets liste = applet.listePr;
    String ch = editeurNom.getText();
    if (((elementAssocie.getNature() & (NatureObjet.NToutPoint | NatureObjet.NDroite)) != 0) && 
            elementAssocie.rendNom().length() != 0) {
      CElementGraphique el = (CPointAncetre) elementAssocie;
      if ((ch.length() == 0) && liste.nomIndispensable(el)) {
        dialogueAvertissement(textes.Chaines.ch33);
        editeurNom.setText(elementAssocie.rendNom());
        return;
      }
    }
    if (liste.validationNomElement(ch)) {
      if (liste.existeMemeNomNonIntermediaire(elementAssocie,ch)) {
        dialogueAvertissement(textes.Chaines.ch20);
        return;
      }
      else {      
        elementAssocie.donneNom(ch);
        applet.repaintFigureSansCalcul();
        dispose();
      }
    }
    else {
      dialogueAvertissement(textes.Chaines.ch19);
      return;
    }
  }                                     

  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {                                          
    dispose();
  }      
}
