/*
 * CBipoint.java
 *
 * Created on 8 juillet 2004, 08:44
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import types.*;

// Aucun objet du type bipoint ne devra jamais tre cr
// Ce type d'objet sert pour dfinir des intersections de droites
// et de cercles ou de cercles
public class CBipoint extends CElementBase {
  CPointDansBipoint point1;
  CPointDansBipoint point2;
  
  /** Creates new CBipoint */
  public CBipoint() {
    // Il faut crer les deux points maintenus par le Bipoint
    point1 = new CPointDansBipoint();
    point2 = new CPointDansBipoint();
  }
  
  public CBipoint(CListeObjets liste,CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
    // Il faut crer les deux points maintenus par le Bipoint
    point1 = new CPointDansBipoint();
    point2 = new CPointDansBipoint();
  }
 
  @Override
  public long getNature() {
    return NatureObjet.NBipoint;
  }
  
  //  pas de Constructeur pour clonage
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    ((CBipoint) ptel).point1.existe = point1.existe;
    ((CBipoint) ptel).point1.x = point1.x;
    ((CBipoint) ptel).point1.y = point1.y;
    ((CBipoint) ptel).point2.existe = point2.existe;
    ((CBipoint) ptel).point2.x = point2.x;
    ((CBipoint) ptel).point2.y = point2.y;
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = (point1.existe) || (point2.existe);
  }
  
  // Renvoie chacun des deux lments dont le reprsente l'intersection
  CElementLigne elementAssocie(byte indice) {
    return null;
  }

  // Fonction dfinie pour la version 2.1 pour amliorer l'outil d'intersection
  // Renvoie true si le bipoint est dfini par la droite Droite
  // A redfinir pour les descendants
  boolean estDefiniPar(CDroiteAncetre droite)
  {
    return false;
  }
  // Fonction dfinie pour la version 2.1 pour amliorer l'outil d'intersection
  // Renvoie true si le bipoint est dfini par le cercle Cercle
  // A redfinir pour les descendants
  boolean estDefiniPar(CCercle cercle)
  {
    return false;
  }
}
