/*
 * OutilCerOA.java
 *
 * Created on 26 fvrier 2006, 09:03
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Outil de cration d'un cercle par centre et point
 */

package outils;

import objets.*;
import types.*;
import Applet.*;

public class OutilCerOA extends OutilPar2pts {
  
  /** Creates a new instance of OutilCer */
  public OutilCerOA(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  public int idMenu() {
    return 32794;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "CercOA.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo5;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip5;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CCercleOA pt = new CCercleOA(appletMere.listePr, null, false, appletMere.couleurActive(),
      false, StyleTrait.traitFin, point1, point2);
    appletMere.ajouteElementAvecVerification(pt);
    appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil4);
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CCercleOA dt = new CCercleOA(appletMere.listeObjetsVisuels, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitPointille,
      point1, appletMere.pointSouris);
    appletMere.listeObjetsVisuels.add(dt);
  }
  
  /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */
          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.cercleOA1;
      case 2 : return textes.Chaines.cercleOA2;
      default: return "";
    }
  }
  
}
