/*
 * OutilDtAB.java
 *
 * Created on 22 fvrier 2006, 18:49
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Outil de cration d'une droite passant par deux points
 */
package outils;

import objets.*;
import types.*;
import Applet.*;


public class OutilDtAB extends OutilPar2pts {
  
  /** Creates a new instance of OutilDtAB */
  public OutilDtAB(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  public int idMenu() {
    return 32783;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DteAB.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo8;
  }  
  
  public String toolTip() {
    return textes.Chaines.toolTip8;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDroiteAB pt = new CDroiteAB(appletMere.listePr, null, false,
      appletMere.couleurActive(), StyleTrait.traitFin, point1, point2, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil7);
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDroiteAB dt = new CDroiteAB(appletMere.listeObjetsVisuels, null, false,
      Couleur.TraduitCouleur(1), StyleTrait.traitPointille,
      point1, appletMere.pointSouris, 2);
    appletMere.listeObjetsVisuels.add(dt);
  }
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return textes.Chaines.droiteAB1;
      case 2 : return textes.Chaines.droiteAB2;
      default: return "";
    }
  }
}
