/*
 * OutilDtePer.java
 *
 * Created on 25 fvrier 2006, 22:55
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Outil de cration d'une droite perpendiculaire
 */
package outils;

import objets.*;
import types.*;
import Applet.*;

public class OutilDtPer extends OutilParDtPt {
  
  /** Creates a new instance of OutilDtePer */
  public OutilDtPer(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 32786;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DtePer.gif";
  }

  public String chaineInfo() {
    return textes.Chaines.chaineInfo10;
  }  
 
  public String toolTip() {
    return textes.Chaines.toolTip10;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDroitePerpendiculaire pt = new CDroitePerpendiculaire(appletMere.listePr, null,
       false, appletMere.couleurActive(), StyleTrait.traitFin, point1, droite1, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil9);
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDroitePerpendiculaire dt = new CDroitePerpendiculaire(appletMere.listeObjetsVisuels,
      null, false, Couleur.TraduitCouleur(1), StyleTrait.traitPointille,
      appletMere.pointSouris, droite1, 2);
    CMarqueAngleDroit marque = new CMarqueAngleDroit(appletMere.listeObjetsVisuels,
            null, false, dt);
    appletMere.listeObjetsVisuels.add(dt);
    appletMere.listeObjetsVisuels.add(marque);
  }
  
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.perpendiculaire1;
      case 2 : return textes.Chaines.perpendiculaire2;
      default: return "";
    }
  }
}
