/*
 * OutilPtLie.java
 *
 * Created on 9 aot 2006, 11:39
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;
import Applet.*;
import java.awt.*;
import java.awt.geom.Point2D;

import objets.*;

import types.*;

/**
 *
 * @author Yves
 */
public class OutilPtLie extends Outil {
  private CElementGraphique elementPourLiaison;
  private int xclic;
  private int yclic;
  
  /** Creates a new instance of OutilPtLie */
  public OutilPtLie(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false);
  }
  
  public int idMenu() {
    return 32800;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "PointLie.gif";
  }
  
 
  public String toolTip() {
    return textes.Chaines.toolTip15;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    elementPourLiaison = null;
    appletMere.outilPointageActif = appletMere.outilPointageCre;
    designationDe(NatureObjet.NTouteDroite + NatureObjet.NToutCercle + NatureObjet.NPolygone
      + NatureObjet.NLigneBrisee);
    appletMere.indication(textes.Chaines.pointLie1);
  }

  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (elementPourLiaison == null) {
      elementPourLiaison = elg;
      xclic = pointClique.x;
      yclic = pointClique.y;
      creeObjet();
    }
  }
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    Doub pointabs = new Doub();
    Point2D.Double pointres = new Point2D.Double();
    CPointLie ptp = null;
    CListeObjets liste = appletMere.listePr;    
    long nat = elementPourLiaison.getNature();
    if ((nat & NatureObjet.NTouteDroite) != 0) {
      ptp = new CPointLieDroite(liste, null, false, appletMere.couleurActive(),
        false, 0d, 0d, false, "", 2, MotifPoint.croix, true, 0,
        (CDroiteAncetre) elementPourLiaison);
    }
    else {
      if ((nat & NatureObjet.NToutCercle) != 0) {
      ptp = new CPointLieCercle(liste, null, false, appletMere.couleurActive(),
        false, 0d, 0d, false, "", 2, MotifPoint.croix, true, 0,
        (CCercle) elementPourLiaison);       
      }
      else {
        if (( nat == NatureObjet.NPolygone) || (nat ==NatureObjet.NLigneBrisee)) {
          ptp = new CPointLieLigne(liste, null, false, appletMere.couleurActive(),
            false, 0d, 0d, false, "", 2, MotifPoint.croix, true, 0,
            (CLignePolygonaleAncetre) elementPourLiaison);              
        }
      }
    }
    ptp.testDeplacement(appletMere.dimf, xclic, yclic, pointres, pointabs);
    ptp.donneAbscisse(pointabs.getValue());
    if (appletMere.ajouteElementAvecVerification(ptp))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil2);
    // AnnuleClignotement repaint la figure mais n'est pas appel ici
    appletMere.repaintFigureSansCalcul();
    select();
  }
}
