package types;
/*
 * InfoLieu.java
 *
 * Created on 13 juillet 2004, 16:43
 */

/**
 *
 * @author  Yves
 * @version
 */
// Java : remplace le InfoLieu
// Dfini les caractristiques d'un lieu de points
import java.io.*;

import objets.CListeObjets;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

// Cette classe a t modifie pour la version 2.5
// en rajoutant un memmre GestionDiscontinuite qui sera true si le lieu
// cre une nouvelle ligne quant la diffrence entre les abscisses ou rodonnes
// entre l'ancienne position et la nouvelle excdent les dimensions de la fentre
public class InfoLieu {
  public int nombreDePoints;
  public boolean fermeOuNon;
  public boolean gestionDiscontinuite;
  
  /** Creates new InfoLieu */
  public InfoLieu() {
  }
  
  public InfoLieu(InfoLieu infoLieuInit) {
    nombreDePoints = infoLieuInit.nombreDePoints;
    fermeOuNon = infoLieuInit.fermeOuNon;
    gestionDiscontinuite = infoLieuInit.gestionDiscontinuite;
  }
  
  public InfoLieu(int nombreDePointsInit, boolean fermeOuNonInit, boolean gestionDiscontinuiteInit) {
  	nombreDePoints = nombreDePointsInit;
  	fermeOuNon = fermeOuNonInit;
  	gestionDiscontinuite = gestionDiscontinuiteInit;
  }
  
  public void setCopy(InfoLieu infoLieuInit) {
    nombreDePoints = infoLieuInit.nombreDePoints;
    fermeOuNon = infoLieuInit.fermeOuNon;
  }
  public void chargeAncienDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    nombreDePoints = inps.readCInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = true;
  }
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    nombreDePoints = inps.readCInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = inps.readBoolean();
  }
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    nombreDePoints = inps.readInt();
    fermeOuNon = inps.readBoolean();
    gestionDiscontinuite = inps.readBoolean();
  }
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    oups.writeInt(nombreDePoints);
    oups.writeBoolean(fermeOuNon);
    oups.writeBoolean(gestionDiscontinuite);
  }
}
